<?php

// Include configuration details. Switch to using Test version when needed.
require_once("firstdata_cfg_Live.php");

function ValidateCC($cardData, $cardAmount) {

// reset any values, if neccessary
 $id = 'New';
 if ($cardData['alumniId'] != '') {$id = $cardData['alumniId'];}
 $expiryMonth = $cardData['expiryMonth'];
 if ($cardData['expiryMonth'] <10) {$expiryMonth = '0'.$expiryMonth;}
 	
// Include soap request packet definition - simpler to modify if it is in a
//   separate file
 
  require_once('SOAPRequest.php');

// initializing cURL with the payment gateway API URL
  $ch = curl_init(FDAPI_URL);

  curl_setopt($ch, CURLOPT_HEADER, 1);

// Verbose logging to be used. Change when in production?
  curl_setopt($ch, CURLOPT_VERBOSE, true);

// This is curl log output - "a" option appends to existing file
//   - Probably remove this once process is running
  $fp = fopen("curl.log", "a");

// Associate stdErr with the log file
  curl_setopt($ch, CURLOPT_STDERR, $fp);

// Set the request type to POST:
  curl_setopt($ch, CURLOPT_POST, 1);

// Set the message content type:
  curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: text/xml"));

// Set authorization method to BASIC:
  curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);

// Supplying credentials:
  curl_setopt($ch, CURLOPT_USERPWD, FD_USERPWD);

// Fill request body with SOAP request:
  curl_setopt($ch, CURLOPT_POSTFIELDS, $requestBody);

// Tell cURL to verify the server certificate:
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

// Set the paths where cURL can find the certificate etc.
  curl_setopt($ch, CURLOPT_SSLCERT, FD_SSLCERT);
  curl_setopt($ch, CURLOPT_SSLKEY, FD_SSLKEY);
  curl_setopt($ch, CURLOPT_SSLKEYPASSWD, FD_SSLKEYPASSWD);

// Tell cURL to return the HTTP response body as the result of curl_exec:
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

// Call cURL and store the SOAP response message.
// Message includes all HTTP headers etc plus the SOAP Envelope
//   If there is a basic level failure response only includes HTML response
//   e.g. If there is a format error or service is unreachable.
  $result = curl_exec($ch);

// Determine start position of SOAP envelope
  $soapStart = strpos($result, '<SOAP-ENV:Envelope');

// Note: SOAP envelope appears to always be at the end of the result string. So
//   we just take the back end of the string as the response.
// Original logic worked out where the end point was and extracted the substring.

  $soapEnvelope = substr($result, $soapStart);

  $obj = simplexml_load_string($soapEnvelope);

// Process response
//   If we have a soap failure set Transaction result element to 'FAIL'
//   otherwise we set the result to the result returned by the API
//   Other fields in the result array are set from message content

// Ensure reply is an array
  $reply = array();

// First check for a soap fault - this would indicate a failure to comply with
//   the rules for the request format.
//   It may also occur if the wdsl rules are broken
  if($obj->children('http://schemas.xmlsoap.org/soap/envelope/')->Body->children('http://schemas.xmlsoap.org/soap/envelope/') && isset($obj->children('http://schemas.xmlsoap.org/soap/envelope/')->Body->children('http://schemas.xmlsoap.org/soap/envelope/')->children()->faultcode)) {
    $reply['TransactionResult'] = 'FAIL';
    $fault = $obj->children('http://schemas.xmlsoap.org/soap/envelope/')->Body->children('http://schemas.xmlsoap.org/soap/envelope/')->children();
    $reply['faultcode'] = (string)$fault->faultcode;
    $reply['faultstring'] = (string)$fault->faultstring;
    $reply['detail'] = (string)$fault->detail;
  }
  else {
    // We got a valid soap response - so now we form the reply from that data
    $response = $obj->children('http://schemas.xmlsoap.org/soap/envelope/')->Body->children('http://secure.linkpt.net/fdggwsapi/schemas_us/fdggwsapi')->FDGGWSApiOrderResponse;

    $reply['TransactionResult'] = (string)$response->TransactionResult;
    $reply['TransactionTime'] = (string)$response->TransactionTime;
    $reply['ErrorMessage'] = (string)$response->ErrorMessage;
    $reply['TransactionID'] = (string)$response->TransactionID;
    $reply['OrderId'] = (string)$response->OrderId;
    $reply['ApprovalCode'] = (string)$response->ApprovalCode;
    $reply['ProcessorReferenceNumber'] = (string)$response->ProcessorReferenceNumber;
    $reply['ProcessorResponseMessage'] = (string)$response->ProcessorResponseMessage;
    $reply['ProcessorResponseCode'] = (string)$response->ProcessorResponseCode;
    $reply['ProcessorResponseCode'] = (string)$response->ç;
    $reply['TransactionScore'] = (string)$response->TransactionScore;
    $reply['FraudAction'] = (string)$response->FraudAction;
    $reply['AuthenticationResponseCode'] = (string)$response->AuthenticationResponseCode;
    $reply['FDGGWSApiOrderResponse'] = (string)$response->FDGGWSApiOrderResponse;
  }

// Close the connection
  curl_close($ch);

// Log details of transaction
  logCC($cardData, $cardAmount, $id, $reply);
  return $reply;
}


function logCC($cardData, $cardAmount, $id, $cardReply) { 
	global $conn;

	// Array of values to be logged
	// All values are character
	// All index names must exist as column names in table CCLOG
	$logData = array('ccNo'=>"",
			'expiryMonth'=>"",
			'expiryYear'=>"",
			'cardAmount'=>"",
			'id'=>"",
			'ccName'=>"",
			'BTaddrLine1'=>"",
			'BTaddrLine2'=>"",
			'BTcity'=>"",
			'BTstate'=>"",
			'BTzip'=>"",
			'BTcountry'=>"",
			'faultcode' =>"",
			'faultstring'=>"",
			'detail' =>"",
			'TransactionResult'=>"",
			'TransactionTime'=>"",
			'ErrorMessage' =>"",
			'TransactionID'=>"",
			'OrderId'=>"",
			'ApprovalCode'=>"",
			'ProcessorReferenceNumber'=>"",
			'ProcessorResponseMessage'=>"",
			'ProcessorResponseCode'=>"",
			'TransactionScore'=>"",
			'FraudAction'=>"",
			'AuthenticationResponseCode'=>"",
			'FDGGWSApiOrderResponse' =>"" );

	// Load the log data from the CC data and the response data
	foreach ($logData  as $key => $value) {
		if (isset($cardData[$key])) { $logData[$key] = $cardData[$key];}
		if (isset($cardReply[$key])) { $logData[$key] = $cardReply[$key];}
	}
	$logData['id'] = $id;                                                                   // Special for id
	$logData['cardAmount'] = $cardAmount;                                   // Special for Amount
	if (strlen(trim($logData['ccNo'])) > 4) {                                      // Strip to last 4 of CC no
		$logData['ccNo'] = substr(trim($logData['ccNo']),-4,4);
	}

	// Build insert statement
	$query = "insert into CCLOG (";
	$prefix = "";
	foreach ($logData  as $key => $value) {
		$query .= $prefix.$key;
		$prefix = " ,";
	}
	$query .= ") values(";
	$prefix = "";
	foreach ($logData  as $key => $value) {
		$query .= $prefix."'".$value."'";
		$prefix = " ,";
	}
	$query .= ") ;";

	if (!$stmt = db2_prepare($conn, $query)) {
		die('prepare failed for <br />'.$query);
	}
	db2_execute($stmt);

}
?>